#include "dispatch.inc"

#ifndef __CWebBrowserEvents2__
#define __CWebBrowserEvents2__

class CWebBrowserEvents2 : CDispatch
{
	declare Initialize(IWebBrowser2 *browser, HWND hwndStatusbar, HWND hwndTitle);
	declare Uninitialize();

	// helper called from Invoke()
	declare InvokeDispatch(DISPPARAMS *pDispParams, int MethodIndex);

	// IUnknown methods: this class should implement DWebBrowserEvents2 interface
	declare virtual QueryInterface(REFIID *riid, void *ppvObject),HRESULT;
	// IDispatch methods
	declare virtual Invoke(DISPID dispIdMember, REFIID *riid, LCID lcid, USHORT wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, UINT *puArgErr);
	// DWebBrowserEvents2 methods
//IMPLEMENTED
	declare virtual StatusTextChange(BSTR Text);
	declare virtual ProgressChange(long Progress, long ProgressMax);
	declare virtual CommandStateChange(long Command, VARIANT_BOOL Enable);
	declare virtual DownloadBegin();
	declare virtual DownloadComplete();
//IMPLEMENTED
	declare virtual TitleChange(BSTR Text);
	declare virtual PropertyChange(BSTR szProperty);
	declare virtual BeforeNavigate2(IDispatch *pDisp, VARIANT* URL, VARIANT *Flags, VARIANT *TargetFrameName, VARIANT *PostData, VARIANT *Headers, VARIANT_BOOL* Cancel);
	declare virtual NewWindow2(IDispatch* ppDisp, VARIANT_BOOL* Cancel);
	declare virtual NavigateComplete2(IDispatch *pDisp, VARIANT *URL);
	declare virtual DocumentComplete(IDispatch *pDisp, VARIANT *URL);
	declare virtual OnQuit();
	declare virtual OnVisible(VARIANT_BOOL Visible);
	declare virtual OnToolBar(VARIANT_BOOL ToolBar);
	declare virtual OnMenuBar(VARIANT_BOOL MenuBar);
	declare virtual OnStatusBar(VARIANT_BOOL StatusBar);
	declare virtual OnFullScreen(VARIANT_BOOL FullScreen);
	declare virtual OnTheaterMode(VARIANT_BOOL TheaterMode);
	declare virtual WindowSetResizable(VARIANT_BOOL Resizable);
	declare virtual WindowSetLeft(long Left);
	declare virtual WindowSetTop(long Top);
	declare virtual WindowSetWidth(long Width);
	declare virtual WindowSetHeight(long Height);
	declare virtual WindowClosing(VARIANT_BOOL IsChildWindow, VARIANT_BOOL* Cancel);
	declare virtual ClientToHostWindow(long* CX, long* CY);
	declare virtual SetSecureLockIcon(long SecureLockIcon);
	declare virtual FileDownload(VARIANT_BOOL* Cancel);
	declare virtual NavigateError(IDispatch *pDisp, VARIANT *URL, VARIANT *Frame, VARIANT *StatusCode, VARIANT_BOOL* Cancel);
	declare virtual PrintTemplateInstantiation(IDispatch *pDisp);
	declare virtual PrintTemplateTeardown(IDispatch *pDisp);
	declare virtual UpdatePageStatus(IDispatch *pDisp, VARIANT *nPage, VARIANT *fDone);
	declare virtual PrivacyImpactedStateChange(VARIANT_BOOL bImpacted);
	declare virtual NewWindow3(IDispatch *ppDisp, VARIANT_BOOL* Cancel, DWORD dwFlags, BSTR bstrUrlContext, BSTR bstrUrl);

	DWORD         m_SinkCookie;	
	ITypeInfo    *m_typeinfo;
	IWebBrowser2 *m_browser;
	HWND          m_hwndStatusbar; // optional handle to statusbar window
	HWND          m_hwndTitle;     // optional handle to a window with title bar
}

#endif

